#! python3
#coding:shift-jis

"""
password Ǘ\tg

pX[h́A (create_datetime) Ɣ閧L[ (key) 쐬B
 create_datetime + key ŁAA̗păpX[h𐶐B
̒lŏꂽWFl[^́A܂̗Ԃ̂ŁA
Ɣ閧L[܂΃pX[h͈ӂɌ܂B



g
1. Python 3.x pāAR}hCN
2. 閧L[͂B͂ȂƊԈpX[hB
3. vvgɈȉ
    3.1. [user];[site]
    
    user  site  ';' ŋ؂ḗBuser, site ͂ǂ炩ȗ\B
    :
    my_name;my_site
    my_name;
    ;my_site
    
    * g\ (* ͔CӒ̔Cӂ̕Ƀ}b`)
    F
    my*;


    3.2.  'q', 'quit'
    I

    3.3. 'u', 'update'
    pX[hXVBVpX[h\̂ŁACɓ܂ u B

    3.4. 'i', 'insert'
    V [UATCgo^
    give user;site[;char-length[;note]]:
    Ƃvvgɑ
    [UATCgAp镶̎ނƃpX[h̒Am[g͂B
    [UATCg͕K{B
    ށApX[h̃ftHgl ASCII, 20

    pX[h̎̕ނƒ͕̓@
    * ނ ASCII R[h̏ꍇ: pX[h̒ ) 18
    * ނ ALNUM Ɍꍇ: 'a' ɑăpX[h̒ ) a16
    * ނ Ɍꍇ: 'd' ɑăpX[h̒ ) d12

    ۂɐpX[h̒͂Ŏw肵
     math.cos(random.random()) { (0.54 -- 1.0 {) ɂȂB
    
    
    3.5. 'd', 'delete'
    I[UATCg폜

    3.6. 'l', 'length'
    pX[h̒AނύX
    3.4 ŏqׂɏ]ē͂B
    ex.) 16, a12, d8

    3.7. 'n', 'note'
    m[gύX

    3.8. 'h', 'help'
    wv\

    3.9. 's', 'show'
    ݂ pw ̑\


̑
Nbv{[hɃpX[hRs[B

"""

import re, time, random, math, functools, os, os.path
from getpass import getpass

if os.name=='nt':
    import win32clipboard

    def copy2clipboard(s0):
        '''copy s0 to clipboard for Windows'''
    
        win32clipboard.OpenClipboard()
        win32clipboard.EmptyClipboard()
        win32clipboard.SetClipboardText(s0)
        win32clipboard.CloseClipboard()

    
elif os.name=='posix':
    import subprocess, platform
    system = platform.system()
    COPY_COMMAND = ['xclip', '-selection', 'c'] if system=='Linux' else \
                   ['pbcopy'] if system=='Darwin' else \
                   None

    if COPY_COMMAND:
        def copy2clipboard(s0):
            '''copy s0 to clipboard for POSIX'''
    
            p = subprocess.Popen(COPY_COMMAND, stdin=subprocess.PIPE)
            p.stdin.write(bytes(s0, encoding='ascii'))
            p.stdin.close()
            p.wait()

    else:
        def copy2clipboard(s0):pass
else:
    def copy2clipboard(s0):pass




class enum(frozenset):
    '''a simple enum class using frozenset'''
    
    def __new__(cls, *rest):
        return frozenset.__new__(cls, rest)

    def __throw(self, k, v=None):
        raise AttributeError('enum object has no attribute: ' + repr(k))
    
    def __getattr__(self, k):
        if k in self: return k
        else: self.__throw(k)

    __setattr__ = __throw



FCODE = enum('HELP', 'QUIT', 'INSERT', 'UPDATE', 'FIND', 'DELETE', 'LENGTH', 'NOTE', 'SHOW')
CHARSET = enum('ASCII', 'ALNUM', 'DIGIT')





class WrongInput(Exception):
    '''excepiton for wrong input'''
    def __init__(self, value):
        self.value=value
    def __str__(self):
        return str(self.value)


def check_input(b, s):
    if not b:
        raise WrongInput(s)





class PW:

    '''password class'''

    # password data file
    FILE = 'pw.txt'

    # password field seperator
    SEP = ';'

    # default length of password
    DEFAULT_LENGTH = 20

    # regexp for valid user and site names
    RE_NAME = re.compile(r'^[\w.@\-]+$')

    # regexp for charset-length code
    # \d+  ==> charset=ASCII, length=int(s)
    # a\d+ ==> charset=ALNUM, length=int(s[1:])
    # d\d+ ==> charset=DIGIT, length=int(s[1:])
    # where s is the charset-length code that the user provides
    RE_CL = re.compile(r'^(?P<charset>[ad])?(?P<length>\d+)$')

    # public properties stored in a PW object
    PROPERTIES = ('user', 'site', 'time', 'length', 'char', 'note')

    # index for charset code
    CHARSET_IDX = 4

    # integer type properties (time and length)
    INT_PARMS = PROPERTIES[2:4]

    # charset for ascii, alnum, and digit
    CS_ASCII = [chr(n) for n in range(32, 127)]
    CS_ALNUM = [c for c in CS_ASCII if c.isalnum()]
    CS_DIGIT = [c for c in CS_ALNUM if c.isdigit()]



    @classmethod
    def p2c(cls, c):
        '''get charset code from prefix'''
        return CHARSET.ALNUM if c=='a' else \
               CHARSET.DIGIT if c=='d' else \
               CHARSET.ASCII


    def __init__(self, ls):
        assert len(ls) == len(PW.PROPERTIES) and ls[PW.CHARSET_IDX] in CHARSET
        self.__h={k : int(v) if k in PW.INT_PARMS else v for k,v in zip(PW.PROPERTIES, ls)}


    def key(self):
        '''pw is identified by user and site'''
        return (self.user, self.site)


    def __cl(self):
        '''return charset-length code of self'''
        assert self.char in CHARSET
        return ('a' if self.char == CHARSET.ALNUM else \
                'd' if self.char == CHARSET.DIGIT else \
                '') + str(self.length)


    def __str__(self):
        '''return string for data file'''
        return PW.SEP.join(str(self.__h[k]) for k in PW.PROPERTIES)


    def __repr__(self):
        '''return string for monitor'''
        return '\n'.join('{0}: {1}'.format( k.title(), self.__h[k] ) for k in PW.PROPERTIES ) 


    def __call__(self, nsec):
        '''calculate password from the created time of self (self.time) and the secret number (nsec)'''
        random.seed(nsec+self.time)
        size = round(self.length * math.cos(random.random()))
        charset = PW.CS_ALNUM if self.char==CHARSET.ALNUM else \
                  PW.CS_DIGIT if self.char==CHARSET.DIGIT else \
                  PW.CS_ASCII
        return ''.join(random.choice(charset) for i in range(size)) 


    def __get(i):
        return lambda s: s.__h[PW.PROPERTIES[i]]


    def __set(i):
        return lambda s,v :s.__h.__setitem__(PW.PROPERTIES[i], v)


    user   = property(__get(0))
    site   = property(__get(1))
    time   = property(__get(2), __set(2))
    length = property(__get(3), __set(3))
    char   = property(__get(4), __set(4))
    note   = property(__get(5), __set(5))
    clcode = property(__cl)





def get_nsec():
    '''getting the secret number
       the user gives a pass phrase and it is converted into a integer value
       using functools.reduce(lambda a,b:(a<<7)+ord(b), s1, 0)
    '''
    while 1:
        try:
            s1 = getpass('give passcode: ')
            s2 = getpass('try again: ')
            check_input(s1==s2, 'The two are not same. Try again.') 
            return functools.reduce(lambda a,b:(a<<7)+ord(b), s1, 0)
        except WrongInput as w:
            print(w)



def read_pws(fname):
    ''' read passwords from the data file'''
    if os.path.isfile(fname):
        with open(fname) as f:
            ls_pw = ( PW(line.rstrip().split(PW.SEP, len(PW.PROPERTIES))) for line in f \
                      if (not line.startswith('#')) and line.count(PW.SEP)+1 == len(PW.PROPERTIES) ) 
            return { pw.key(): pw  for pw in ls_pw }
    else:
        return dict()



def write_pws(fname, h):
    '''write passwords to the data file'''
    with open(fname, 'w') as f:
        f.write('#user;site;create_time;length;char_set;note\n' + \
                '\n'.join(str(x) for x in h.values())           + \
                '\n')



def amatch(tpat, ts):
    '''match  patterns for user and site names (tpat)
       to actual user and site names of a password (ts)'''
    return all(amatch_each(tpat[i], ts[i]) for i in range(2))



def amatch_each(pat, s):
    '''match each pattern to a string, * is only one wild card to represent ".*" '''
    return (not pat) or \
       (re.match('^' + pat.replace('.', '\\.').replace('*', '.*') + '$', s) if ('*' in pat) \
       else pat==s)



def find_pw(s0, h):
    '''finding pw from the dict of passwords'''
    check_input(s0.count(PW.SEP)==1, 'two fields should be separated by ' + repr(PW.SEP)) 
    tput = s0.split(PW.SEP)
    ls = [ v for k,v in h.items() if amatch(tput, k) ]
    check_input(ls, 'Cannot find in the DB')
    return ls[ 0 if len(ls)==1 else which_pw(ls) ] 



def which_pw(ls):
    '''let the user select a password if more than one matched'''
    assert len(ls)>1
    for i, x in enumerate(ls):
        print ('{num}: {user};{site}'.format(num=i, user=x.user, site=x.site))
    while 1:
        try:
            y=input('Which one? ')
            check_input(y.isdigit(), 'give number.') 
            n=int(y)
            check_input(0 <= n < len(ls), 'out of range.')
            return n
        except WrongInput as w:
            print (w)



def update_pw(pw, c):
    check_input(pw, 'pw is not specified')
    if c==FCODE.UPDATE:
        pw.time = get_now()
    elif c==FCODE.NOTE:
        print('Current Value:', pw.note)
        s0=input('new value (just RET to unchange): ')
        if s0: 
            pw.note = s0
    elif c==FCODE.LENGTH:
        print('Current Value:', pw.clcode)
        s0=input('new value (just RET to unchange): ')
        if s0:
            pw.char, pw.length = get_clen(s0)
    else:
        raise WrongInput('Unsupported Function Code')



def check_new_pw(tup, h):
    '''check if the password is not in the DB and the user and site names are valid'''
    check_input(tup not in h, 'already exists')
    for k,v in zip(PW.PROPERTIES, tup):
        check_input(PW.RE_NAME.match(v), 'Invalid {} name'.format(k)) 



def new_pw(s0, h):
    check_input(0<s0.count(PW.SEP)<4, 'Wrong number of fields')
    ls=s0.split(PW.SEP)
    check_new_pw(tuple(ls[:2]), h) 
    chrset, length = get_clen(ls[2]) if len(ls)>2 and ls[2] else (CHARSET.ASCII, PW.DEFAULT_LENGTH)
    note = ls[3] if len(ls)>3 else ''
    return PW([ls[0], ls[1], get_now(), length, chrset, note])



def get_clen(s0):
    '''get charset and length of password from input string'''
    m = PW.RE_CL.match(s0)
    check_input(m, 'Wrong format for charset-lenght')
    return PW.p2c(m.group('charset')), int(m.group('length'))



def show_pw(nsec, pw):
    '''showing password string'''
    check_input(pw, 'pw is not specified')
    password = pw(nsec)
    print('{0};{1}: {2}'.format(pw.user, pw.site, password))
    copy2clipboard(password)



def show_help():
    print(\
      'u(update): update password for current user and site\n' \
      'i(insert): create password for newe user and site\n' \
      'd(delete): delete record for current user and site\n' \
      'user;site: show password for user;site\n'  \
      'l(length): show/change length and charset (ex. 12, a10, d8)\n'  \
      'n(note):   show/change note\n'                  \
      'h(help):   show help\n' \
      'q(quit):   terminate\n' \
      )



def get_now():
    '''getting elapsed seconds from epoc as integer'''
    return int(time.time())



def parse_input(s0):
    c = FCODE.QUIT    if s0 in ('q', 'quit')   else \
        FCODE.HELP    if s0 in ('h', 'help')   else \
        FCODE.UPDATE  if s0 in ('u', 'update') else \
        FCODE.INSERT  if s0 in ('i', 'insert') else \
        FCODE.DELETE  if s0 in ('d', 'delete') else \
        FCODE.LENGTH  if s0 in ('l', 'length') else \
        FCODE.NOTE    if s0 in ('n', 'note')   else \
        FCODE.SHOW    if s0 in ('s', 'show')   else \
        FCODE.FIND    if s0.count(PW.SEP)==1   else \
        ''
    check_input(c in FCODE, 'Unsupported Command')
    return (c,s0)



if __name__ == '__main__':
    nsec = get_nsec()
    h_pw = read_pws(PW.FILE)
    pw, c = None, None
    while 1:
        try:
            c, s0 = parse_input(input('{0};{1}> '.format(*pw.key()) if pw else '> '))
            copy2clipboard('')

            if   c==FCODE.QUIT:
                break
            elif c==FCODE.HELP:
                show_help()
                continue
            elif c==FCODE.FIND:
                pw=find_pw(s0, h_pw)
            elif c==FCODE.INSERT:
                pw=new_pw(input('give user;site[;char-length[;note]]: '), h_pw)
                h_pw[pw.key()]=pw
            elif c in (FCODE.UPDATE, FCODE.NOTE, FCODE.LENGTH):
                update_pw(pw, c)
            elif c==FCODE.SHOW:
                print('\n', repr(pw), '\n', sep='')
            elif c==FCODE.DELETE:
                del h_pw[pw.key()]
                continue
            else:
                raise WrongInput('Unsupported Command')

            show_pw(nsec, pw)

        except WrongInput as w:
            print(w)

        finally:
            if c in (FCODE.INSERT, FCODE.UPDATE, FCODE.NOTE, FCODE.LENGTH, FCODE.DELETE):
                write_pws(PW.FILE, h_pw)
